import { Description } from "./Description";
import { Type } from "./type";
import { AxisAnnotationDescription } from "./AxisAnnotationDescription";
import { FormatSpecifierDescription } from "./FormatSpecifierDescription";
/**
 * @hidden
 */
export declare abstract class AxisDescription extends Description {
    static $t: Type;
    protected get_type(): string;
    get type(): string;
    constructor();
    private b6;
    get formatLabelRef(): string;
    set formatLabelRef(a: string);
    private co;
    get title(): string;
    set title(a: string);
    private cm;
    get stroke(): string;
    set stroke(a: string);
    private b3;
    get actualStroke(): string;
    set actualStroke(a: string);
    private ay;
    get strokeThickness(): number;
    set strokeThickness(a: number);
    private l;
    get strokeDashArray(): number[];
    set strokeDashArray(a: number[]);
    private cl;
    get strip(): string;
    set strip(a: string);
    private ch;
    get majorStroke(): string;
    set majorStroke(a: string);
    private b1;
    get actualMajorStroke(): string;
    set actualMajorStroke(a: string);
    private aw;
    get majorStrokeThickness(): number;
    set majorStrokeThickness(a: number);
    private j;
    get majorStrokeDashArray(): number[];
    set majorStrokeDashArray(a: number[]);
    private ci;
    get minorStroke(): string;
    set minorStroke(a: string);
    private b2;
    get actualMinorStroke(): string;
    set actualMinorStroke(a: string);
    private ax;
    get minorStrokeThickness(): number;
    set minorStrokeThickness(a: number);
    private k;
    get minorStrokeDashArray(): number[];
    set minorStrokeDashArray(a: number[]);
    private cn;
    get tickStroke(): string;
    set tickStroke(a: string);
    private a0;
    get tickStrokeThickness(): number;
    set tickStrokeThickness(a: number);
    private m;
    get tickStrokeDashArray(): number[];
    set tickStrokeDashArray(a: number[]);
    private az;
    get tickLength(): number;
    set tickLength(a: number);
    private v;
    get isDisabled(): boolean;
    set isDisabled(a: boolean);
    private w;
    get isInverted(): boolean;
    set isInverted(a: boolean);
    private y;
    get shouldAvoidAnnotationCollisions(): boolean;
    set shouldAvoidAnnotationCollisions(a: boolean);
    private z;
    get shouldKeepAnnotationsInView(): boolean;
    set shouldKeepAnnotationsInView(a: boolean);
    private ac;
    get usePerLabelHeightMeasurement(): boolean;
    set usePerLabelHeightMeasurement(a: boolean);
    private ab;
    get useEnhancedIntervalManagement(): boolean;
    set useEnhancedIntervalManagement(a: boolean);
    private bx;
    get enhancedIntervalMinimumCharacters(): number;
    set enhancedIntervalMinimumCharacters(a: number);
    private t;
    get enhancedIntervalPreferMoreCategoryLabels(): boolean;
    set enhancedIntervalPreferMoreCategoryLabels(a: boolean);
    private ce;
    get labelTextColor(): string;
    set labelTextColor(a: string);
    private cd;
    get labelLocation(): string;
    set labelLocation(a: string);
    private x;
    get labelShowFirstLabel(): boolean;
    set labelShowFirstLabel(a: boolean);
    private an;
    get labelAngle(): number;
    set labelAngle(a: number);
    private ap;
    get labelExtent(): number;
    set labelExtent(a: number);
    private as;
    get labelMaximumExtent(): number;
    set labelMaximumExtent(a: number);
    private at;
    get labelMaximumExtentPercentage(): number;
    set labelMaximumExtentPercentage(a: number);
    private ar;
    get labelLeftMargin(): number;
    set labelLeftMargin(a: number);
    private au;
    get labelRightMargin(): number;
    set labelRightMargin(a: number);
    private av;
    get labelTopMargin(): number;
    set labelTopMargin(a: number);
    private ao;
    get labelBottomMargin(): number;
    set labelBottomMargin(a: number);
    private cc;
    get labelHorizontalAlignment(): string;
    set labelHorizontalAlignment(a: string);
    private cf;
    get labelVerticalAlignment(): string;
    set labelVerticalAlignment(a: string);
    private b5;
    get crossingAxisRef(): string;
    set crossingAxisRef(a: string);
    private bz;
    get crossingValue(): any;
    set crossingValue(a: any);
    private cu;
    get titlePosition(): string;
    set titlePosition(a: string);
    private cv;
    get titleTextColor(): string;
    set titleTextColor(a: string);
    private ct;
    get titleLocation(): string;
    set titleLocation(a: string);
    private aa;
    get titleShowFirstLabel(): boolean;
    set titleShowFirstLabel(a: boolean);
    private a1;
    get titleAngle(): number;
    set titleAngle(a: number);
    private a3;
    get titleExtent(): number;
    set titleExtent(a: number);
    private a6;
    get titleMaximumExtent(): number;
    set titleMaximumExtent(a: number);
    private a7;
    get titleMaximumExtentPercentage(): number;
    set titleMaximumExtentPercentage(a: number);
    private a5;
    get titleLeftMargin(): number;
    set titleLeftMargin(a: number);
    private a8;
    get titleRightMargin(): number;
    set titleRightMargin(a: number);
    private a9;
    get titleTopMargin(): number;
    set titleTopMargin(a: number);
    private a2;
    get titleBottomMargin(): number;
    set titleBottomMargin(a: number);
    private cs;
    get titleHorizontalAlignment(): string;
    set titleHorizontalAlignment(a: string);
    private cw;
    get titleVerticalAlignment(): string;
    set titleVerticalAlignment(a: string);
    private h;
    get annotations(): AxisAnnotationDescription[];
    set annotations(a: AxisAnnotationDescription[]);
    private b4;
    get coercionMethodsRef(): string;
    set coercionMethodsRef(a: string);
    private u;
    get expectFunctions(): boolean;
    set expectFunctions(a: boolean);
    private cb;
    get labelFormat(): string;
    set labelFormat(a: string);
    private i;
    get labelFormatSpecifiers(): FormatSpecifierDescription[];
    set labelFormatSpecifiers(a: FormatSpecifierDescription[]);
    private cj;
    get rangeChangedRef(): string;
    set rangeChangedRef(a: string);
    private ck;
    get renderRequestedRef(): string;
    set renderRequestedRef(a: string);
    private b7;
    get label(): string;
    set label(a: string);
    private b8;
    get labelFontFamily(): string;
    set labelFontFamily(a: string);
    private aq;
    get labelFontSize(): number;
    set labelFontSize(a: number);
    private ca;
    get labelFontWeight(): string;
    set labelFontWeight(a: string);
    private b9;
    get labelFontStyle(): string;
    set labelFontStyle(a: string);
    private cp;
    get titleFontFamily(): string;
    set titleFontFamily(a: string);
    private a4;
    get titleFontSize(): number;
    set titleFontSize(a: number);
    private cr;
    get titleFontWeight(): string;
    set titleFontWeight(a: string);
    private cq;
    get titleFontStyle(): string;
    set titleFontStyle(a: string);
    private cg;
    get labelVisibility(): string;
    set labelVisibility(a: string);
}
