import { Description } from "./Description";
import { Type } from "./type";
import { WebFilteringOperandDescription } from "./WebFilteringOperandDescription";
import { WebSortingStrategyDescription } from "./WebSortingStrategyDescription";
import { WebColumnPipeArgsDescription } from "./WebColumnPipeArgsDescription";
import { WebColumnEditorOptionsDescription } from "./WebColumnEditorOptionsDescription";
/**
 * @hidden
 */
export declare class WebColumnDescription extends Description {
    static $t: Type;
    protected get_type(): string;
    get type(): string;
    private static __canMarshalByValue;
    private static __marshalByValueAlias;
    constructor();
    private bn;
    get field(): string;
    set field(a: string);
    private bq;
    get header(): string;
    set header(a: string);
    private b3;
    get title(): string;
    set title(a: string);
    private ag;
    get sortable(): boolean;
    set sortable(a: boolean);
    private ae;
    get selectable(): boolean;
    set selectable(a: boolean);
    private y;
    get groupable(): boolean;
    set groupable(a: boolean);
    private v;
    get editable(): boolean;
    set editable(a: boolean);
    private w;
    get filterable(): boolean;
    set filterable(a: boolean);
    private ac;
    get resizable(): boolean;
    set resizable(a: boolean);
    private s;
    get autosizeHeader(): boolean;
    set autosizeHeader(a: boolean);
    private z;
    get hasSummary(): boolean;
    set hasSummary(a: boolean);
    private aa;
    get hidden(): boolean;
    set hidden(a: boolean);
    private af;
    get selected(): boolean;
    set selected(a: boolean);
    private t;
    get disableHiding(): boolean;
    set disableHiding(a: boolean);
    private u;
    get disablePinning(): boolean;
    set disablePinning(a: boolean);
    private b4;
    get width(): string;
    set width(a: string);
    private bw;
    get maxWidth(): string;
    set maxWidth(a: string);
    private br;
    get headerClasses(): string;
    set headerClasses(a: string);
    private ba;
    get headerStyles(): any;
    set headerStyles(a: any);
    private bs;
    get headerGroupClasses(): string;
    set headerGroupClasses(a: string);
    private a9;
    get headerGroupStyles(): any;
    set headerGroupStyles(a: any);
    private bi;
    get cellClassesRef(): string;
    set cellClassesRef(a: string);
    private bj;
    get cellStylesRef(): string;
    set cellStylesRef(a: string);
    private bp;
    get formatterRef(): string;
    set formatterRef(a: string);
    private b1;
    get summaryFormatterRef(): string;
    set summaryFormatterRef(a: string);
    private x;
    get filteringIgnoreCase(): boolean;
    set filteringIgnoreCase(a: boolean);
    private ah;
    get sortingIgnoreCase(): boolean;
    set sortingIgnoreCase(a: boolean);
    private ad;
    get searchable(): boolean;
    set searchable(a: boolean);
    private bk;
    get dataType(): string;
    set dataType(a: string);
    private a2;
    get rowEnd(): number;
    set rowEnd(a: number);
    private a0;
    get colEnd(): number;
    set colEnd(a: number);
    private a3;
    get rowStart(): number;
    set rowStart(a: number);
    private a1;
    get colStart(): number;
    set colStart(a: number);
    private a8;
    get additionalTemplateContext(): any;
    set additionalTemplateContext(a: any);
    private bx;
    get minWidth(): string;
    set minWidth(a: string);
    private ab;
    get pinned(): boolean;
    set pinned(a: boolean);
    private b0;
    get summariesRef(): string;
    set summariesRef(a: string);
    private h;
    get disabledSummaries(): string[];
    set disabledSummaries(a: string[]);
    private n;
    get filters(): WebFilteringOperandDescription;
    set filters(a: WebFilteringOperandDescription);
    private p;
    get sortStrategy(): WebSortingStrategyDescription;
    set sortStrategy(a: WebSortingStrategyDescription);
    private b2;
    get summaryTemplateRef(): string;
    set summaryTemplateRef(a: string);
    private bh;
    get bodyTemplateRef(): string;
    set bodyTemplateRef(a: string);
    private bt;
    get headerTemplateRef(): string;
    set headerTemplateRef(a: string);
    private bv;
    get inlineEditorTemplateRef(): string;
    set inlineEditorTemplateRef(a: string);
    private bl;
    get errorTemplateRef(): string;
    set errorTemplateRef(a: string);
    private bo;
    get filterCellTemplateRef(): string;
    set filterCellTemplateRef(a: string);
    private ai;
    get visibleWhenCollapsed(): boolean;
    set visibleWhenCollapsed(a: boolean);
    private l;
    get pipeArgs(): WebColumnPipeArgsDescription;
    set pipeArgs(a: WebColumnPipeArgsDescription);
    private j;
    get editorOptions(): WebColumnEditorOptionsDescription;
    set editorOptions(a: WebColumnEditorOptionsDescription);
    private bb;
    get parentColumn(): any;
    set parentColumn(a: any);
    private by;
    get name(): string;
    set name(a: string);
    private bu;
    get hiddenChangeRef(): string;
    set hiddenChangeRef(a: string);
    private bm;
    get expandedChangeRef(): string;
    set expandedChangeRef(a: string);
    private b5;
    get widthChangeRef(): string;
    set widthChangeRef(a: string);
    private bz;
    get pinnedChangeRef(): string;
    set pinnedChangeRef(a: string);
}
