import { IgxDataLegendSeriesValueInfo } from "./igx-data-legend-series-value-info";
import { DataLegendSummaryColumn as DataLegendSummaryColumn_internal } from "./DataLegendSummaryColumn";
/**
 * Represent a column in summary row
*/
export declare class IgxDataLegendSummaryColumn extends IgxDataLegendSeriesValueInfo {
    protected createImplementation(): DataLegendSummaryColumn_internal;
    /**
                                 * @hidden
                                 */
    get i(): DataLegendSummaryColumn_internal;
    constructor();
    /**
     * Get values of series in the summary column
    */
    get seriesValues(): number[];
    static ngAcceptInputType_seriesValues: number[] | string;
    /**
     * Get labels rendered on left side of series values, e.g. "H:" for High, "L:" for Low
    */
    get seriesLabels(): string[];
    static ngAcceptInputType_seriesLabels: string[] | string;
    /**
     * Get optional units on right side of series values, e.g. "Hz" for hertz
    */
    get seriesUnits(): string[];
    static ngAcceptInputType_seriesUnits: string[] | string;
    /**
     * Add a value in the summary column
    
    */
    addValue(value: number): void;
    /**
     * Add label in the summary column
    
    */
    addLabel(label: string): void;
    /**
     * Add unit in the summary column
    
    */
    addUnits(units: string): void;
}
