import { EventEmitter } from '@angular/core';
import { ItfConverter as ItfConverter_internal } from "./ItfConverter";
import { IgxAsyncCompletedEventArgs } from './igx-async-completed-event-args';
import { TriangulationSourcePointRecord } from './TriangulationSourcePointRecord';
import { Triangle } from './Triangle';
/**
 * Class for converting Itf files into enumerable triangulations.
*/
export declare class IgxTriangulationDataSource {
    protected createImplementation(): ItfConverter_internal;
    protected _implementation: any;
    get i(): ItfConverter_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * Gets the string path specifying the location of the Itf file.
    */
    get source(): string;
    /**
     * Sets the string path specifying the location of the Itf file.
    */
    set source(v: string);
    /**
    * Gets the point data.
    */
    getPointData(): TriangulationSourcePointRecord[];
    /**
    * Gets the triangle data.
    */
    getTriangleData(): Triangle[];
    findByName(name: string): any;
    protected _zoneRunner: (act: () => void) => void;
    protected _runInZone(act: () => void): void;
    private _importCompleted;
    /**
     * Event raised when the import operation has completed
    */
    get importCompleted(): EventEmitter<{
        sender: any;
        args: IgxAsyncCompletedEventArgs;
    }>;
}
